include \masm32\include\masm32rt.inc

.586
.data?
freqct	dd 16 dup(?)	; for testing the frequency

.code
start:
	mov ebx, 8000000	; 8000000 -> expected frequency 500,000
	.Repeat
		call Rand15	; get a random number between 0 and 15
		inc freqct[4*eax]	; count its frequency
		dec ebx
	.Until Sign?
	mov ebx, 15
	.Repeat
		print str$(ebx), 9
		mov eax, freqct[4*ebx]
		print str$(eax), 13, 10
		dec ebx
	.Until Sign?
	print chr$(13, 10, "Codesize=")
	mov eax, Rand15_endp
	sub eax, Rand15_s
	print str$(eax), " bytes"
	getkey
	exit

Rand15_s:
Rand15 proc
.data?
r9Seed	dd ?
.code
	mov eax, r9Seed
	push edx
	push ecx
	test eax, eax
	jne @F
	invoke Sleep, eax	; spend some cycles here and there
	invoke GetTickCount	; get a seed value
	mov r9Seed, eax
@@:	ffree st(7)	; free a rarely used FP register
	mov ecx, 0FFFFFFH
	and eax, ecx
	inc eax	; make sure it's not zero
	push eax
	fldpi	; push PI on FPU
	fimul dword ptr [esp]	; 3.14159*[1...edx+1]
	rdtsc	; we'll use only the loword
	and eax, ecx	; and 0FFFFFFH
	inc eax	; make sure it's not zero
	mov [esp], eax	; second external influence is rdtsc
	fimul dword ptr [esp]	; *(rdtsc and 0FFFFFFH)
	pop eax
	fstp r9Seed	; now a cheap trick: pop a Real4 from the FPU ...
	mov eax, r9Seed	; ... but mov an integer ;-)
	and eax, 15	; return a number between 0 and 15
	pop ecx	; restore two
	pop edx	; precious registers
	ret
Rand15 endp
Rand15_endp:
end start

OPT_Tmp2Asm	1
